/*
 * Software License Agreement (BSD License)
 *
 * Copyright (c) 2018 Oliver Mayer, Akademie der Bildenden Kuenste Nuernberg. 
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */


/*****************************************************************************  
 *  Primitive Datentypen und deren Wertebereiche
 *****************************************************************************/

String myString;  // Zeichenkette für Textrepräsentation

boolean blValue;  // Bool'sche Variable: Kann nur 'true' oder 'false' sein

// -- primitive Datentypen für ganze Zahlen --
byte bValue;      // byte Variable:  1 Byte
short sValue;     // short Variable: 2 Byte
int iValue;       // int Variable:   4 Byte
long lValue;      // long Variable:  8 Byte

// -- primitive Datentypen für Gleitkommazahlen
float fValue;     // float Variable:  4 Byte
double dValue;    // double Variable: 8 Byte


void setup() {
  // Fenstergroesse 600x300
  size(600, 300);
  
  // Textgroesse
  textSize(20); 
}


void draw() {

  if (mouseX < width/2) {
    // Maus befindet sich in der linken Hälfte des Fensters 
    
    // setze die Variablen auf kleinstmöglichen Wert 
    blValue = false;
    bValue = Byte.MIN_VALUE;
    sValue = Short.MIN_VALUE;
    iValue = Integer.MIN_VALUE;
    lValue = Long.MIN_VALUE;
    fValue = Float.MIN_VALUE;
    dValue = Double.MIN_VALUE;
    
    // fülle linke Hälfte mit kräftigem Rot
    fill(0, 0, 200);
    rect(0, 0, width/2, height);
    
    // fülle rechte Hälfte mit schwachem Blau
    fill(100, 0, 0);
    rect(width/2, 0, width/2, height);
  }
  else {
    // Maus befindet sich in der rechten Hälfte des Fensters 
    
    // setze die Variablen auf größtmöglichen Wert 
    blValue = true;
    bValue = Byte.MAX_VALUE;
    sValue = Short.MAX_VALUE;
    iValue = Integer.MAX_VALUE;
    lValue = Long.MAX_VALUE;
    fValue = Float.MAX_VALUE;
    dValue = Double.MAX_VALUE; 
    
    // fülle linke Hälfte mit schwachem Rot
    fill(0, 0, 100);
    rect(0, 0, width/2, height);
    
    // fülle rechte Hälfte mit kräftigem Blau
    fill(200, 0, 0);
    rect(width/2, 0, width/2, height);
  }
  
  // erstelle Zeichenkette für Textanzeige
  myString =  "bool   value = " + blValue + "\n";
  myString += "byte   value = " + bValue + "\n";
  myString += "short  value = " + sValue + "\n";
  myString += "int    value = " + iValue + "\n";
  myString += "long   value = " + lValue + "\n";
  myString += "float  value = " + fValue + "\n";
  myString += "double value = " + dValue + "\n";
  
  
  // Textfarbe (gelb)
  fill(255, 255, 153);
  // zeichne 'myString' an Position x=50,y=50
  text(myString, 50, 50);
}